package me.akito123321.valoStrats.db;
import java.net.URI;
import java.net.URISyntaxException;

import javax.sql.DataSource;

import org.springframework.boot.jdbc.DataSourceBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import me.akito123321.valoStrats.ValoStratsApplication;

@Configuration
public class DataSourceConfig {

	@Bean
	public DataSource getDataSource() {
		MySQLConfig mySQL = ValoStratsApplication.config.sqlConfig();

		DataSourceBuilder<?> dsb = DataSourceBuilder.create();
		URI jdbcURL;
		try {
			jdbcURL = new URI("jdbc:mariadb", null, mySQL.host(), mySQL.port(), "/" + mySQL.database(), "createDatabaseIfNotExist=true", null);
		} catch (URISyntaxException e) {
			throw new RuntimeException("Failed to config data source", e);
		}

		dsb.url(jdbcURL.toString());
		dsb.username(mySQL.username());
		dsb.password(mySQL.password());
		return dsb.build();
	}

}